structure GtkCellRendererState :> GTK_CELL_RENDERER_STATE =
  struct
    val SELECTED = 0w1
    val PRELIT = 0w2
    val INSENSITIVE = 0w4
    val SORTED = 0w8
    val FOCUSED = 0w16
    val EXPANDABLE = 0w32
    val EXPANDED = 0w64
    val allFlags =
      [
        SELECTED,
        PRELIT,
        INSENSITIVE,
        SORTED,
        FOCUSED,
        EXPANDABLE,
        EXPANDED
      ]
    structure Flags =
      Flags(
        val allFlags = allFlags
      )
    open Flags
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gtk_cell_renderer_state_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val getValue_ = call (getSymbol "g_value_get_flags") (GObjectValueRecord.PolyML.cPtr --> PolyML.cVal)
      val setValue_ = call (getSymbol "g_value_set_flags") (GObjectValueRecord.PolyML.cPtr &&> PolyML.cVal --> cVoid)
    end
    val t =
      ValueAccessor.C.createAccessor
        {
          getType = (I ---> GObjectType.FFI.fromVal) getType_,
          getValue = (I ---> FFI.fromVal) getValue_,
          setValue = (I &&&> FFI.withVal ---> I) setValue_
        }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
